/*
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License") you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code in this file was released April 1, 2001
 * 
 * The Initial Developer of the Original Code is Henk-Johan van Rantwijk.
 * all Portions created by Henk-Johan van Rantwijk are Copyright (C) 2001
 * by Henk-Johan van Rantwijk. All Rights Reserved.
 * 
 * Contributor(s):
 *   Henk-Johan van Rantwijk <bugs4hj@netscape.net> (Original Author)
 *   David Perry <d.perry@utoronto.ca>
 *   Neil Pryde <NeilPryde92651@netscape.net> (well I'm just HJ's typewriter)
 * 
 */

////////////////////////////////////////////////////////////////////////////////
// this function switches the tab position from top to bottom or bottom to top
////////////////////////////////////////////////////////////////////////////////
function switchTabPosition()
{
  var switchButton = document.getElementById( "mvSwitchIcon" );

  if ( mvPrefs.TopTabs ) { // Tabs on top of window active
    copyTabs( "multiviewTabBox", "TabBoxBottom" );
    mvPrefs.TopTabs = false;
    setTabProperty( "true", "false" );
    document.getElementById( "multiviewTabBox" ).setAttribute( "id", "TabBoxTop" );
    document.getElementById( "TabBoxBottom" ).setAttribute( "id", "multiviewTabBox" );
    switchButton.setAttribute( "src", "chrome://multiviews/skin/icons/color/top.gif" );
  }
  else { // Tabs on the bottom of window active
    copyTabs( "multiviewTabBox", "TabBoxTop" );
    mvPrefs.TopTabs = true;
    setTabProperty( "false", "true" );
    document.getElementById( "multiviewTabBox" ).setAttribute( "id", "TabBoxBottom" );
    document.getElementById( "TabBoxTop" ).setAttribute( "id", "multiviewTabBox" );
		switchButton.setAttribute( "src", "chrome://multiviews/skin/icons/color/bottom.gif" );
  }
  mvGlobal.TabboxElement = document.getElementById( "multiviewTabBox" );
  mvPrefs.HiddenTabs = false; // we have displayed the tabs, so reset this
  toggleShowHideButton();

}
////////////////////////////////////////////////////////////////////////////////
// this function sets the tab property hidden to true/false
////////////////////////////////////////////////////////////////////////////////
function setTabProperty( top, bottom )
{

  document.getElementById( "TabBoxTop-0" ).setAttribute( "hidden", top );
  document.getElementById( "TabBoxTop-1" ).setAttribute( "hidden", top );
  document.getElementById( "TabBoxTop-2" ).setAttribute( "hidden", top );
  document.getElementById( "TabBoxBottom-0" ).setAttribute( "hidden", bottom );
  document.getElementById( "TabBoxBottom-1" ).setAttribute( "hidden", bottom );
  document.getElementById( "TabBoxBottom-2" ).setAttribute( "hidden", bottom );
}
////////////////////////////////////////////////////////////////////////////////
// this function copy the tabs from multiviewTabBox to the new tabbox
////////////////////////////////////////////////////////////////////////////////
function copyTabs( from, to )
{

  var fromTabboxElement = document.getElementById( from );
  var toTabboxElement = document.getElementById( to );

  if ( fromTabboxElement == null || toTabboxElement == null ) 
    dump( 'Error: in function copyTabs()' );

  while ( fromTabboxElement.hasChildNodes() ) {
    toTabboxElement.appendChild( fromTabboxElement.firstChild );

    if ( mvPrefs.TopTabs ) {
      if ( mvPrefs.StatusLeds )
        toTabboxElement.lastChild.setAttribute( "class", "tab-bottom tab-green" );
      else
        toTabboxElement.lastChild.setAttribute( "class", "tab-bottom" );
    }
    else {
      if ( mvPrefs.StatusLeds )
        toTabboxElement.lastChild.setAttribute( "class", "tab tab-green" );
      else
        toTabboxElement.lastChild.setAttribute( "class", "tab" );
    }
  }
}
////////////////////////////////////////////////////////////////////////////////
// this function hide/shows the tabs on our deck and changes the button state
////////////////////////////////////////////////////////////////////////////////
function toggleTabs()
{
  var mvTabboxIdA = new Array( 'TabBoxBottom-0', 'TabBoxTop-0' );
  var mvTabboxIdB = new Array( 'TabBoxBottom-1', 'TabBoxTop-1' );
  var mvTabboxIdC = new Array( 'TabBoxBottom-2', 'TabBoxTop-2' );
  var mvIndex = mvPrefs.TopTabs ? 1 : 0; // index to select tabs

  if ( mvPrefs.HiddenTabs ) { // unhide tabs if theye are hidden
    document.getElementById( mvTabboxIdA[ mvIndex ] ).removeAttribute( "hidden" );
    document.getElementById( mvTabboxIdB[ mvIndex ] ).removeAttribute( "hidden" );
    document.getElementById( mvTabboxIdC[ mvIndex ] ).removeAttribute( "hidden" );
    mvPrefs.HiddenTabs = false;
  }
  else { // hide all visual tabs
    document.getElementById( mvTabboxIdA[ mvIndex ] ).setAttribute( "hidden", "true" );
    document.getElementById( mvTabboxIdB[ mvIndex ] ).setAttribute( "hidden", "true" );
    document.getElementById( mvTabboxIdC[ mvIndex ] ).setAttribute( "hidden", "true" );
    mvPrefs.HiddenTabs = true;
  }
  // _content.focus();
  toggleShowHideButton();
}
////////////////////////////////////////////////////////////////////////////////
// this function switches the tabs orientation by CTRL-PAGE-UP/CTRL-PAGE-DOWN
////////////////////////////////////////////////////////////////////////////////
function switchTabsTo( orientation )
{

  // TODO: this can't be true is it?
  if ( ( orientation == 'top' ) && ( mvPrefs.TopTabs == false ) ) {
    switchTabPosition();
  }
  else if ( ( orientation == 'bottom' ) && ( mvPrefs.TopTabs == true ) ) {
    switchTabPosition();
  }
}
////////////////////////////////////////////////////////////////////////////////
// this function shows/hides all toolbars, navigator and the status bar
////////////////////////////////////////////////////////////////////////////////
function toggleMaxBrowserMode()
{
  if( mvGlobal.MaxMode ) {
    // disable MultiZilla's custom navigation toolbox
    mvGlobal.urlBar = gURLBar = document.getElementById("urlbar");
    document.getElementById( "NavButtons" ).setAttribute( "hidden", "true" );
    updateURLBar( getCurrentContentURI() );

    if ( mvGlobal.MaxMode & mTB_MAIN ) {
      goToggleToolbar( 'main-menubar', 'cmd_viewmenubar' );
    }
    if ( mvGlobal.MaxMode & mTB_NAV ) {
      goToggleToolbar( 'nav-bar', 'cmd_viewnavbar' );
    }
    if ( mvGlobal.MaxMode & mTB_PTB ) {
      goToggleToolbar( 'PersonalToolbar', 'cmd_viewPersonalToolbar' );
    }
    if ( mvGlobal.MaxMode & mTB_TOOL ) {
      goToggleToolbar( 'MultiZillaToolbar', 'cmd_viewMultiZillaToolbar' );
    }
    if ( mvGlobal.MaxMode & mTB_TASK ) {
      goToggleToolbar( 'status-bar', 'cmd_viewtaskbar' );
    }
    mvGlobal.MaxMode = 0;
  }
  else {
    if ( mvGlobal.MainMenu.getAttribute( "hidden" ) != "true" ) {
      goToggleToolbar( 'main-menubar', 'cmd_viewmenubar' );
      mvGlobal.MaxMode+=mTB_MAIN;
    }
    if ( mvGlobal.NavBar.getAttribute( "hidden" ) != "true" ) {
      goToggleToolbar( 'nav-bar', 'cmd_viewnavbar' );
      mvGlobal.MaxMode+=mTB_NAV;
    }
    if ( mvGlobal.PersonalToolbar.getAttribute( "hidden" ) != "true" ) {
      goToggleToolbar( 'PersonalToolbar', 'cmd_viewPersonalToolbar' );
      mvGlobal.MaxMode+=mTB_PTB;
    }
    if ( mvGlobal.Toolbar.getAttribute( "hidden" ) != "true" ) {
      goToggleToolbar( 'MultiZillaToolbar', 'cmd_viewMultiZillaToolbar' );
      mvGlobal.MaxMode+=mTB_TOOL;
    }
    if ( mvGlobal.Taskbar.getAttribute( "hidden" ) != "true" ) {
      goToggleToolbar( 'status-bar', 'cmd_viewtaskbar' );
      mvGlobal.MaxMode+=mTB_TASK;
    }
  }
}

