/*
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License") you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code in this file was released April 1, 2001
 * 
 * The Initial Developer of the Original Code is Henk-Johan van Rantwijk.
 * all Portions created by Henk-Johan van Rantwijk are Copyright (C) 2001
 * by Henk-Johan van Rantwijk. All Rights Reserved.
 * 
 * Contributor(s):r
 *   Henk-Johan van Rantwijk <bugs4hj@netscape.net> (Original Author)
 *   David Perry <d.perry@utoronto.ca>
 *   Neil Pryde <NeilPryde92651@netscape.net> (well I'm just HJ's typewriter)
 * 
*/

////////////////////////////////////////////////////////////////////////////////
// this function updates the URLbar with the given URL
////////////////////////////////////////////////////////////////////////////////
function updateURLBar( url )
{
  if ( url && url != "about:blank" )
    mvGlobal.urlBar.value = url;
  else mvGlobal.urlBar.value = "";
  // loadFavIcon(url, "image", gProxyFavIcon);
}
////////////////////////////////////////////////////////////////////////////////
// this function updates the content title
////////////////////////////////////////////////////////////////////////////////
function updateContentTitle( tabNode )
{
  if ( tabNode && tabNode == mvGlobal.TabboxElement.selectedItem ) { // .selectedTab
    var docTitle = getBrowser().contentDocument.title;
    var newTitle = "";

    if ( docTitle ) {
      newTitle += mvGlobal.titlepreface;
      newTitle += docTitle;
      newTitle += mvGlobal.titlemenuseparator;
    }
    newTitle += mvGlobal.titlemodifier;
    window.title = newTitle;
  }
}
////////////////////////////////////////////////////////////////////////////////
// this function updates the tab Tooltip description
////////////////////////////////////////////////////////////////////////////////
function updateTooltip( tabNode )
{
  var url            = null;
  var shortURL       = null;
  var viewNode       = null;
  var newTooltipText = null;
 
  if ( tabNode == null ) {
    url         = getCurrentContentURI();
    shortURL    = defineShortURL( url );
    viewNode    = getBrowser();
    tabNode     = mvGlobal.TabboxElement.selectedItem; // selectedTab;
    viewport    = tabNode.getAttribute( "viewport" );
  }
  else {
    var viewport = tabNode.getAttribute( "viewport" );
    viewNode = mvGlobal.DeckElement.childNodes[ viewport ];
    url      = viewNode.webNavigation.currentURI.spec;
    shortURL = defineShortURL( url );
  }
  mvGlobal.LinkList[ viewport ] = url;
  // thanks to Neil Parkway <neil@parkwaycc.co.uk>
  var leafName      = url.replace(/[&\?].*/,'').replace(/.*[:\/]/,'')

  if (leafName == "" )
    leafName = "index.html";

  if ( mvPrefs.DevTooltips ) {
    var viewportNr = tabNode.getAttribute( "viewport" );
    viewportNr++;
    newTooltipText = 'Tab-' + viewportNr + ' - ' + shortURL + ' - ' + leafName;
  }
	else {
    newTooltipText = viewNode.contentDocument.title;
    if ( newTooltipText == "" )
      newTooltipText = "Untitled or blank page";
  }
  tabNode.setAttribute( "tooltiptext", newTooltipText );
}
////////////////////////////////////////////////////////////////////////////////
//
// Block with functions related to: URL's
//
////////////////////////////////////////////////////////////////////////////////
// this function loads the given URL after a short delay (mvGlobal.LoadDelay)
////////////////////////////////////////////////////////////////////////////////
function loadViewURI( url )
{
  // setTimeout( "loadURI('"+url+"')", mvGlobal.LoadDelay );
  setTimeout( loadURI, mvGlobal.LoadDelay, url );
  // getWebNavigation().loadURI(url, nsIWebNavigation.LOAD_FLAGS_NONE, null, null, null);
}
////////////////////////////////////////////////////////////////////////////////
// this function loads an URI and updates stickyName
////////////////////////////////////////////////////////////////////////////////
function loadNewURI()
{
  // TODO: we need make our own dialog for this
  BrowserOpenWindow();
  // var mvLink = mvGlobal.TabboxElement.selectedTab.getAttribute( "link" );
  var mvLink = mvGlobal.TabboxElement.selectedItem.getAttribute( "link" );
  var currentURL = getCurrentContentURI();
  document.getElementById(mvLink).setAttribute( "home", currentURL );
  updateTabLocation();
}
////////////////////////////////////////////////////////////////////////////////
// this function returns the current URL
////////////////////////////////////////////////////////////////////////////////
function getCurrentContentURI()
{
  try {
    return getWebNavigation().currentURI.spec;
  } catch ( e ) {
    return mvGlobal.HomePage;
  }
}
////////////////////////////////////////////////////////////////////////////////
// this function displays the url in the status region of the active window
////////////////////////////////////////////////////////////////////////////////
function showUrl( event )
{
  var viewLink = event.target.getAttribute( "link" );

  if ( viewLink )
    window.status = document.getElementById( viewLink ).contentDocument.location.href;

  return true;
}
////////////////////////////////////////////////////////////////////////////////
// this returns a short URL from the given url, used for stickyName
////////////////////////////////////////////////////////////////////////////////
function defineShortURL( aURI )
{
  var i = aURI.indexOf(":");

  if ( i != -1 ) {
    while( !isAlphaNum( aURI[ i ] ) )
      i++;
    return aURI.substring( i, aURI.length );
  }
  return aURI;
}
////////////////////////////////////////////////////////////////////////////////
// this function returns the URL read from the clipboard
////////////////////////////////////////////////////////////////////////////////
function getLocationFromClipboard()
{
  var url;

  try {
    var clipboard = Components.classes[ "@mozilla.org/widget/clipboard;1" ]
                              .getService(Components.interfaces.nsIClipboard);

    var trans = Components.classes[ "@mozilla.org/widget/transferable;1" ]
                          .createInstance(Components.interfaces.nsITransferable);

    trans.addDataFlavor( "text/unicode" );
    clipboard.getData( trans, clipboard.kGlobalClipboard );

    var data = {};
    var dataLen = {};
    trans.getTransferData( "text/unicode", data, dataLen );

    if ( data ) {
      data = data.value.QueryInterface( Components.interfaces.nsISupportsWString );
      url = data.data.substring( 0, dataLen.value / 2 );
    }
    else {
      url = 'about:blank';
      alert('Sorry, Clipboard contains no data');
    }
  } catch ( ex ) {
    alert( 'Warning: Read From Clipboard Error' );
  }
  return url;
}
////////////////////////////////////////////////////////////////////////////////
// this function stores the given url in a array
////////////////////////////////////////////////////////////////////////////////
function storeURL( url )
{
  // mvLinkList[ mvGlobal.TotalTabs ] = url;
  mvGlobal.LinkList[ mvGlobal.SelectedTab ] = url;
}
////////////////////////////////////////////////////////////////////////////////
// this function checks if the given url is stored in mvLinkList
////////////////////////////////////////////////////////////////////////////////
function checkStoredURL( url )
{
  for ( var i = 0; i <= mvGlobal.TotalTabs; i++ ) {
    if ( mvGlobal.LinkList[ i ] == url || mvGlobal.LinkList[ i ] == url + '/' )
      return ( i );
  }
  return ( -1 );
}
////////////////////////////////////////////////////////////////////////////////
//
// Block with functions related to: General functions
//
////////////////////////////////////////////////////////////////////////////////
// this function returns the content document
////////////////////////////////////////////////////////////////////////////////
function getCurrentContentDocument()
{
  return getBrowser().contentDocument;
}
////////////////////////////////////////////////////////////////////////////////
// this function displays the current software version number
////////////////////////////////////////////////////////////////////////////////
function displayVersion()
{
  var mVersion = getBrowser().mVersion;
  window.openDialog( "chrome://multiviews/content/multiviewsAbout.xul",
                     "multiviewsClose", "chrome, dialog, dependent", 
                      mVersion, loadURI );
}
////////////////////////////////////////////////////////////////////////////////
// this function checks the website for a new update of MultiZilla
////////////////////////////////////////////////////////////////////////////////
function doCheck4Updates()
{
  var mVersion = getBrowser().mVersion;
  getBrowser().addTab( 'http://multizilla.mozdev.org/update.html?version=' + mVersion );
}
////////////////////////////////////////////////////////////////////////////////
// this function handles the ShutDown stuff
////////////////////////////////////////////////////////////////////////////////
function validateThisPage( aURL )
{
  if ( aURL ) {
    var IOService = Components.classes[ "@mozilla.org/network/io-service;1" ].
                               getService( Components.interfaces.nsIIOService );

    if (!IOService)
       return;
    var scheme = "";

    try {
     scheme = IOService.extractScheme( aURL, {schemeStartPos:0}, {schemeEndPos:0});
    } catch ( ex ) { alert('error') }

    if ( scheme == "http" ) {
      var checkURL = "http://validator.w3.org/check?uri=" + aURL + 
                     "&charset=%28detect+automatically%29&doctype=Inline";
      getBrowser().addTab( checkURL );
    }
    else alert( "Can't handle used protocol type "+ scheme +":\nThis validator supports http: only" );
  }
}
////////////////////////////////////////////////////////////////////////////////
// this feature is implemented to clear both memory and disk-cache as well as 
// (url) history info, on special request by some anonymous dirty people, haha
// sorry, but I had to add this type of comment, just for the fun part of it :-)
////////////////////////////////////////////////////////////////////////////////
function clearAllBackTraces()
{
  var globalHistory = Components.classes["@mozilla.org/browser/global-history;1"]
                                .getService(Components.interfaces.nsIBrowserHistory);
  globalHistory.removeAllPages();

  var urlBarHistory = Components.classes["@mozilla.org/browser/urlbarhistory;1"]
                                .getService(Components.interfaces.nsIUrlbarHistory);
  urlBarHistory.clearHistory();

  var classID       = Components.classes["@mozilla.org/network/cache-service;1"];
  var cacheService  = classID.getService(Components.interfaces.nsICacheService);
  cacheService.evictEntries(Components.interfaces.nsICache.STORE_ON_DISK);
  cacheService.evictEntries(Components.interfaces.nsICache.STORE_IN_MEMORY);
}
////////////////////////////////////////////////////////////////////////////////
// this function gets a localized string from chrome:multiviews.properties
////////////////////////////////////////////////////////////////////////////////
function getTextFromBundle(aStr) {
  var multiviewsBundle = "chrome://multiviews/locale/multiviews.properties";
  var aBundle = srGetStrBundle( multiviewsBundle );
  var aLabel = aBundle.GetStringFromName( aStr );
  return aLabel;
}
////////////////////////////////////////////////////////////////////////////////
// this function returns true if a given string is all alphanumeric
// Adapted from chrome/content/communitcator/pref/pref-languages.js
////////////////////////////////////////////////////////////////////////////////
function isAlphaNum(mixedCase) {
  var allCaps = mixedCase.toUpperCase();
  for (var i = allCaps.length - 1; i >= 0; i--) {
    var c = allCaps.charAt(i);
    if ((c < 'A' || c > 'Z') && (c < '0' || c > '9') && (c!='_'))
      return false;
  }
  return true;
}
